Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.imageio.stream
Class FileImageOutputStream

    java.lang.Object
      |
      +--javax.imageio.stream.ImageInputStreamImpl
            |
            +--javax.imageio.stream.ImageOutputStreamImpl
                  |
                  +--javax.imageio.stream.FileImageOutputStream

All Implemented Interfaces:
  DataInput, DataOutput, ImageInputStream, ImageOutputStream

public class FileImageOutputStream
extends ImageOutputStreamImpl

An implementation of `ImageOutputStream` that writes its output directly to a `File` or `RandomAccessFile`.

Field Summary

Fields inherited from class javax.imageio.stream.ImageInputStreamImpl
`bitOffset, byteOrder, flushedPos, streamPos`

Constructor Summary
`FileImageOutputStream(File f)` Constructs a `FileImageOutputStream` that will write to a given `File`.
`FileImageOutputStream(RandomAccessFile raf)` Constructs a `FileImageOutputStream` that will write to a given `RandomAccessFile`.

Method Summary
`void` | `close()` Closes the stream.
`long` | `length()` Returns the total length of the stream, if known.
`int` | `read()` Reads a single byte from the stream and returns it as an integer between 0 and 255.
`int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`.
`void` | `seek(long pos)` Sets the current stream position and resets the bit offset to 0.
`void` | `write(byte[] b, int off, int len)` Writes a sequence of bytes to the stream at the current position.
`void` | `write(int b)` Writes a single byte to the stream at the current position.

Methods inherited from class javax.imageio.stream.ImageOutputStreamImpl
`flushBits, write, writeBit, writeBits, writeBoolean, writeByte, writeBytes, writeChar, writeChars, writeChars, writeDouble, writeDoubles, writeFloat, writeFloats, writeInt, writeInts, writeLong, writeLongs, writeShort, writeShorts, writeUTF`

Methods inherited from class javax.imageio.stream.ImageInputStreamImpl
`checkClosed, finalize, flush, flushBefore, getBitOffset, getByteOrder, getFlushedPosition, getStreamPosition, isCached, isCachedFile, isCachedMemory, mark, read, readBit, readBits, readBoolean, readByte, readBytes, readChar, readDouble, readFloat, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedInt, readUnsignedShort, readUTF, reset, setBitOffset, setByteOrder, skipBytes, skipBytes`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.imageio.stream.ImageOutputStream
`flushBefore`

Methods inherited from interface javax.imageio.stream.ImageInputStream
`flush, getBitOffset, getByteOrder, getFlushedPosition, getStreamPosition, isCached, isCachedFile, isCachedMemory, mark, read, readBit, readBits, readBoolean, readByte, readBytes, readChar, readDouble, readFloat, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedInt, readUnsignedShort, readUTF, reset, setBitOffset, setByteOrder, skipBytes, skipBytes`

Constructor Detail

### FileImageOutputStream

    public FileImageOutputStream(File f)
                          throws FileNotFoundException,
                                 IOException

  Constructs a `FileImageOutputStream` that will write to a given `File`.

Parameters:
  `f` - a `File` to write to.
Throws:
  `IllegalArgumentException` - if `f` is `null`.
  `SecurityException` - if a security manager exists and does not allow write access to the file.
  `FileNotFoundException` - if `f` is a directory or cannot be opened for reading and writing for any other reason.
  `IOException` - if an I/O error occurs.

### FileImageOutputStream

    public FileImageOutputStream(RandomAccessFile raf)

  Constructs a `FileImageOutputStream` that will write to a given `RandomAccessFile`.

Parameters:
  `raf` - a `RandomAccessFile` to write to.
Throws:
  `IllegalArgumentException` - if `raf` is `null`.

Method Detail

### read

    public int read()
             throws IOException

  Description copied from interface: `ImageInputStream`
  Reads a single byte from the stream and returns it as an integer between 0 and 255. If the end of the stream is reached, -1 is returned.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `read` in interface `ImageInputStream`
  Specified by:
    `read` in class `ImageInputStreamImpl`
  Returns:
    a byte value from the stream, as an int, or -1 to indicate EOF.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Description copied from interface: `ImageInputStream`
  Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`. The number of bytes read is returned. If no bytes can be read because the end of the stream has been reached, `-1` is returned.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `read` in interface `ImageInputStream`
  Specified by:
    `read` in class `ImageInputStreamImpl`
  Parameters:
    `b` - an array of bytes to be written to.
    `off` - the starting position within `b` to write to.
    `len` - the maximum number of `byte`s to read.
  Returns:
    the number of bytes actually read, or `-1` to indicate EOF.
  Throws:
    `IOException` - if an I/O error occurs.

### write

    public void write(int b)
               throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a single byte to the stream at the current position. The 24 high-order bits of `b` are ignored.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write. Implementers can use the ``flushBits`` method of ``ImageOutputStreamImpl`` to guarantee this.

  Specified by:
    `write` in interface `ImageOutputStream`
  Specified by:
    `write` in class `ImageOutputStreamImpl`
  Parameters:
    `b` - an `int` whose lower 8 bits are to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### write

    public void write(byte[] b,
                      int off,
                      int len)
               throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of bytes to the stream at the current position. If `len` is 0, nothing is written. The byte `b[off]` is written first, then the byte `b[off + 1]`, and so on.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write. Implementers can use the ``flushBits`` method of ``ImageOutputStreamImpl`` to guarantee this.

  Specified by:
    `write` in interface `ImageOutputStream`
  Specified by:
    `write` in class `ImageOutputStreamImpl`
  Parameters:
    `b` - an array of `byte`s to be written.
    `off` - the start offset in the data.
    `len` - the number of `byte`s to write.
  Throws:
    `IOException` - if an I/O error occurs.

### length

    public long length()

  Description copied from interface: `ImageInputStream`
  Returns the total length of the stream, if known. Otherwise, `-1` is returned.

  Specified by:
    `length` in interface `ImageInputStream`
  Overrides:
    `length` in class `ImageInputStreamImpl`
  Returns:
    a `long` containing the length of the stream, if known, or else `-1`.

### seek

    public void seek(long pos)
              throws IOException

  Sets the current stream position and resets the bit offset to 0. It is legal to seeking past the end of the file; an `EOFException` will be thrown only if a read is performed. The file length will not be increased until a write is performed.

  Specified by:
    `seek` in interface `ImageInputStream`
  Overrides:
    `seek` in class `ImageInputStreamImpl`
  Parameters:
    `pos` - a `long` containing the desired file pointer position.
  Throws:
    `IndexOutOfBoundsException` - if `pos` is smaller than the flushed position.
    `IOException` - if any other I/O error occurs.

### close

    public void close()
               throws IOException

  Description copied from interface: `ImageInputStream`
  Closes the stream. Attempts to access a stream that has been closed may result in `IOException`s or incorrect behavior. Calling this method may allow classes implementing this interface to release resources associated with the stream such as memory, disk space, or file descriptors.

  Specified by:
    `close` in interface `ImageInputStream`
  Overrides:
    `close` in class `ImageInputStreamImpl`
  Throws:
    `IOException` - if an I/O error occurs.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.